Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.xqj
Class SaxonDuration

    java.lang.Object
      javax.xml.datatype.Duration
          net.sf.saxon.xqj.SaxonDuration

    public class SaxonDuration

extends Duration

Saxon implementation of the JAXP class javax.xml.datatype.Duration. This is currently used only by the XQJ interface for XQuery: the normal representation of a duration in Saxon is the class `DurationValue`.

The JAXP specification for this class defines it in terms of XML Schema 1.0 semantics. This defines a structure with six independent components (year, month, day, hour, minute, second). This implementation is more aligned to the XPath 2.0 semantics of the data type, which essentially defines duration as an integer number of months plus a decimal number of seconds.

Constructor Summary
`SaxonDuration(DurationValue duration)` Create a SaxonDuration that wraps a supplied DurationValue

Method Summary
`Duration` | `add(Duration rhs)` Computes a new duration whose value is `this+rhs`.
`void` | `addTo(Calendar calendar)` Adds this duration to a `Calendar` object.
`int` | `compare(Duration rhs)` Partial order relation comparison with this `Duration` instance.
`DurationValue` | `getDurationValue()` Get the underlying DurationValue
`Number` | `getField(DatatypeConstants.Field field)` Gets the value of a field.
`int` | `getSign()` Returns the sign of this duration in -1,0, or 1.
`QName` | `getXMLSchemaType()` Get the type of this duration, as one of the values xs:duration, xs:dayTimeDuration, or xs:yearMonthDuration.
`int` | `hashCode()` Returns a hash code consistent with the definition of the equals method.
`boolean` | `isSet(DatatypeConstants.Field field)` Checks if a field is set.
`Duration` | `multiply(BigDecimal factor)` Computes a new duration whose value is `factor` times longer than the value of this duration.
`Duration` | `negate()` Returns a new `Duration` object whose value is `-this`.
`Duration` | `normalizeWith(Calendar startTimeInstant)` Converts the years and months fields into the days field by using a specific time instant as the reference point.
`Duration` | `subtract(Duration rhs)` Computes a new duration whose value is `this-rhs`.

Methods inherited from class javax.xml.datatype.Duration
`addTo, equals, getDays, getHours, getMinutes, getMonths, getSeconds, getTimeInMillis, getTimeInMillis, getYears, isLongerThan, isShorterThan, multiply, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SaxonDuration

    public SaxonDuration(DurationValue duration)

  Create a SaxonDuration that wraps a supplied DurationValue

  Parameters:
    `duration` - the value to be wrapped.

Method Detail

### getDurationValue

    public DurationValue getDurationValue()

  Get the underlying DurationValue

### getXMLSchemaType

    public QName getXMLSchemaType()

  Get the type of this duration, as one of the values xs:duration, xs:dayTimeDuration, or xs:yearMonthDuration. (Note that the XML Schema namespace URI is used, whereas the current implementation of the superclass uses a provisional URI allocated in a 2003 W3C working draft)

  Overrides:
    `getXMLSchemaType` in class `Duration`
  Returns:
    the type of this duration, as one of the values xs:duration, xs:dayTimeDuration, or xs:yearMonthDuration

### getSign

    public int getSign()

  Returns the sign of this duration in -1,0, or 1.

  Specified by:
    `getSign` in class `Duration`
  Returns:
    -1 if this duration is negative, 0 if the duration is zero, and 1 if the duration is positive.

### getField

    public Number getField(DatatypeConstants.Field field)

  Gets the value of a field.

  Fields of a duration object may contain arbitrary large value. Therefore this method is designed to return a `Number` object.

  In case of YEARS, MONTHS, DAYS, HOURS, and MINUTES, the returned number will be a non-negative integer. In case of seconds, the returned number may be a non-negative decimal value.

  Specified by:
    `getField` in class `Duration`
  Parameters:
    `field` - one of the six Field constants (YEARS,MONTHS,DAYS,HOURS, MINUTES, or SECONDS.)
  Returns:
    If the specified field is present, this method returns a non-null non-negative `Number` object that represents its value. If it is not present, return null. For YEARS, MONTHS, DAYS, HOURS, and MINUTES, this method returns a `BigInteger` object. For SECONDS, this method returns a `BigDecimal`.
  Throws:
    `NullPointerException` - If the `field` is `null`.

### isSet

    public boolean isSet(DatatypeConstants.Field field)

  Checks if a field is set. In this implementation, all fields are always set.

  Specified by:
    `isSet` in class `Duration`
  Parameters:
    `field` - one of the six Field constants (YEARS,MONTHS,DAYS,HOURS, MINUTES, or SECONDS.)
  Returns:
    This implementation always returns true.

### add

    public Duration add(Duration rhs)

  Computes a new duration whose value is `this+rhs`.

  This implementation follows the XPath semantics. This means that the operation will fail if the duration is not a yearMonthDuration or a dayTimeDuration.

  Specified by:
    `add` in class `Duration`
  Parameters:
    `rhs` - `Duration` to add to this `Duration`
  Returns:
    non-null valid Duration object.
  Throws:
    `NullPointerException` - If the rhs parameter is null.
    `IllegalStateException` - If the durations are not both dayTimeDurations, or both yearMonthDurations.
  See Also:
    `subtract(javax.xml.datatype.Duration)`

### subtract

    public Duration subtract(Duration rhs)

  Computes a new duration whose value is `this-rhs`.

  This implementation follows the XPath semantics. This means that the operation will fail if the duration is not a yearMonthDuration or a dayTimeDuration.

  Overrides:
    `subtract` in class `Duration`
  Parameters:
    `rhs` - `Duration` to subtract from this `Duration`
  Returns:
    non-null valid Duration object.
  Throws:
    `NullPointerException` - If the rhs parameter is null.
    `IllegalStateException` - If the durations are not both dayTimeDurations, or both yearMonthDurations.
  See Also:
    `add(javax.xml.datatype.Duration)`

### addTo

    public void addTo(Calendar calendar)

  Adds this duration to a `Calendar` object.

  Calls `Calendar.add(int,int)` in the order of YEARS, MONTHS, DAYS, HOURS, MINUTES, SECONDS, and MILLISECONDS if those fields are present. Because the `Calendar` class uses int to hold values, there are cases where this method won't work correctly (for example if values of fields exceed the range of int.)

  Also, since this duration class is a Gregorian duration, this method will not work correctly if the given `Calendar` object is based on some other calendar systems.

  Any fractional parts of this `Duration` object beyond milliseconds will be simply ignored. For example, if this duration is "P1.23456S", then 1 is added to SECONDS, 234 is added to MILLISECONDS, and the rest will be unused.

  Note that because `Calendar.add(int, int)` is using `int`, `Duration` with values beyond the range of `int` in its fields will cause overflow/underflow to the given `Calendar`. `XMLGregorianCalendar.add(javax.xml.datatype.Duration)` provides the same basic operation as this method while avoiding the overflow/underflow issues.

  Specified by:
    `addTo` in class `Duration`
  Parameters:
    `calendar` - A calendar object whose value will be modified.
  Throws:
    `NullPointerException` - if the calendar parameter is null.

### multiply

    public Duration multiply(BigDecimal factor)

  Computes a new duration whose value is `factor` times longer than the value of this duration.

  This implementation follows the XPath semantics. This means that it is defined only on yearMonthDuration and dayTimeDuration. Other cases produce an IllegalStateException.

  Specified by:
    `multiply` in class `Duration`
  Parameters:
    `factor` - to multiply by
  Returns:
    returns a non-null valid `Duration` object
  Throws:
    `IllegalStateException` - if operation produces fraction in the months field.
    `NullPointerException` - if the `factor` parameter is `null`.

### negate

    public Duration negate()

  Returns a new `Duration` object whose value is `-this`.

  Since the `Duration` class is immutable, this method doesn't change the value of this object. It simply computes a new Duration object and returns it.

  Specified by:
    `negate` in class `Duration`
  Returns:
    always return a non-null valid `Duration` object.

### normalizeWith

    public Duration normalizeWith(Calendar startTimeInstant)

  Converts the years and months fields into the days field by using a specific time instant as the reference point.

  This implementation does not support this method

  Specified by:
    `normalizeWith` in class `Duration`
  Parameters:
    `startTimeInstant` - `Calendar` reference point.
  Returns:
    `Duration` of years and months of this `Duration` as days.
  Throws:
    `NullPointerException` - If the startTimeInstant parameter is null.
    `UnsupportedOperationException` - Always thrown by this implementation.

### compare

    public int compare(Duration rhs)

  Partial order relation comparison with this `Duration` instance.

  This implementation follows the XPath semantics. This means that the result is defined only for dayTimeDuration and yearMonthDuration values, and the result is never indeterminate.

  Return:

  - `DatatypeConstants.LESSER` if this `Duration` is shorter than `duration` parameter
  - `DatatypeConstants.EQUAL` if this `Duration` is equal to `duration` parameter
  - `DatatypeConstants.GREATER` if this `Duration` is longer than `duration` parameter
  - `DatatypeConstants.INDETERMINATE` if a conclusive partial order relation cannot be determined

  Specified by:
    `compare` in class `Duration`
  Parameters:
    `rhs` - duration to compare
  Returns:
    the relationship between `this` `Duration`and `duration` parameter as `DatatypeConstants.LESSER`, `DatatypeConstants.EQUAL`, `DatatypeConstants.GREATER` or `DatatypeConstants.INDETERMINATE`.
  Throws:
    `UnsupportedOperationException` - If the underlying implementation cannot reasonably process the request, e.g. W3C XML Schema allows for arbitrarily large/small/precise values, the request may be beyond the implementations capability.
    `NullPointerException` - if `duration` is `null`.
    `IllegalArgumentException` - if the operands are not dayTimeDuration or yearMonthDuration values.
  See Also:
    `Duration.isShorterThan(javax.xml.datatype.Duration)`, `Duration.isLongerThan(javax.xml.datatype.Duration)`

### hashCode

    public int hashCode()

  Returns a hash code consistent with the definition of the equals method.

  Specified by:
    `hashCode` in class `Duration`
  See Also:
    `Object.hashCode()`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.